#include<stdlib.h>
#include<string.h>
#include"argon.h"


t_state *alloc_state(int N)
{
	t_state *res=malloc(sizeof(t_state));

	memset(res, 0, sizeof(t_state));

	res->r=malloc(sizeof(t_coord)*N);
	res->p=malloc(sizeof(t_coord)*N);
	res->F=malloc(sizeof(t_coord)*N);
	res->locked=malloc(sizeof(int)*N);
	res->damping=malloc(sizeof(double)*N);
	
	memset(res->r, 0, sizeof(t_coord)*N);
	memset(res->p, 0, sizeof(t_coord)*N);
	memset(res->F, 0, sizeof(t_coord)*N);
	memset(res->locked, 0, sizeof(int)*N);
	memset(res->damping, 0, sizeof(double)*N);

	res->N=N;
	
	return res;
}

void free_state(t_state *state)
{
	free(state->r);
	free(state->p);
	free(state->F);
	free(state->locked);
	free(state);
}

void copy_state(t_state *dest, t_state *src)
{
	memcpy(dest->r, src->r, sizeof(t_coord)*src->N);
	memcpy(dest->p, src->p, sizeof(t_coord)*src->N);
	memcpy(dest->F, src->F, sizeof(t_coord)*src->N);
	memcpy(dest->locked, src->locked, sizeof(int)*src->N);

	dest->N=src->N;

	dest->V=src->V;
	dest->P=src->P;
	dest->H=src->H;

	dest->T=src->T;
	dest->t=src->t;

	dest->step=src->step;
}

void load_parameters(t_parameters *pars, char *fname)
{
	FILE *f=fopen(fname, "r");

	fscanf(f, "%d %*[^\n]\n", &pars->n);
	pars->N=pars->n*pars->n*pars->n;

	fscanf(f, "%lf %*[^\n]\n", &pars->m);
	fscanf(f, "%lf %*[^\n]\n", &pars->e);
	fscanf(f, "%lf %*[^\n]\n", &pars->R);
	fscanf(f, "%lf %*[^\n]\n", &pars->f);
	fscanf(f, "%lf %*[^\n]\n", &pars->L);

	fscanf(f, "%lf %*[^\n]\n", &pars->a);
	fscanf(f, "%lf %*[^\n]\n", &pars->T_0);

	fscanf(f, "%lf %*[^\n]\n", &pars->tau);
	fscanf(f, "%d %*[^\n]\n", &pars->S_o);
	fscanf(f, "%d %*[^\n]\n", &pars->S_d);

	fscanf(f, "%d %*[^\n]\n", &pars->S_out);
	fscanf(f, "%d %*[^\n]\n", &pars->S_avs);

	/*
	printf("%d\n", pars->n);
	printf("%d\n", pars->N);

	printf("%lf\n", pars->m);
	printf("%lf\n", pars->e);
	printf("%lf\n", pars->R);
	printf("%lf\n", pars->f);
	printf("%lf\n", pars->L);

	printf("%lf\n", pars->a);
	printf("%lf\n", pars->T_0);

	printf("%lf\n", pars->tau);
	printf("%d\n", pars->S_o);
	printf("%d\n", pars->S_d);

	printf("%d\n", pars->S_out);
	printf("%d\n", pars->S_avs);
	*/
}


void save_state(FILE *f, t_state *state)
{
	fprintf(f, "%f %f %f %f %f \n", state->t, state->H, state->V, state->T, state->P);
}

void save_state_xyz(FILE *f, t_state *state)
{

	if(!f) return;

	int N=state->N;

	for(int i=0; i<N; i++) {
		fprintf(f, "%d %lf %lf %lf\n", i, state->r[i].x, state->r[i].y, state->r[i].z);
	}
}
